﻿local buttons = {
	MainMenuMicroButton,
	CharacterMicroButton,
	SpellbookMicroButton,
	TalentMicroButton,
	AchievementMicroButton,
	QuestLogMicroButton,
	GuildMicroButton,
	LFDMicroButton,
	CollectionsMicroButton,
	EJMicroButton,
	StoreMicroButton,
	MainMenuBarBackpackButton,
	CharacterBag0Slot,
	CharacterBag1Slot,
	CharacterBag2Slot,
	CharacterBag3Slot,
};

local done = false;
local MicroButtonsBorder = CreateFrame("Frame", "MicroButtonBorder");
local addon = CreateFrame("Frame", "HideMicroButtonAndBagsBar");
addon:RegisterEvent("PLAYER_ENTERING_WORLD");
addon:RegisterEvent("UNIT_ENTERING_VEHICLE");
addon:RegisterEvent("UNIT_EXITING_VEHICLE");
local onload = false;
addon:SetScript("OnEvent", function(self, event)
	if event == "PLAYER_ENTERING_WORLD" and not onload then
		self:initialize();
		onload = true;
	elseif event == "UNIT_ENTERING_VEHICLE" then
		MicroButtonAndBagsBar:SetParent(OverrideActionBar);
		self:HideMBAG();
	elseif event == "UNIT_EXITING_VEHICLE" then
		MicroButtonAndBagsBar:SetParent(MainMenuBar);
		self:HideMBAG();
	end
end);

function GetAnchor1()
	if HideMicroButtonAndBags["Positions"] == "Right" then
		return "BOTTOMLEFT";
	else
		return "BOTTOMRIGHT";
	end
end

function GetAnchor2()
	if HideMicroButtonAndBags["Positions"] == "Right" then
		return "BOTTOMRIGHT";
	else
		return "BOTTOMLEFT";
	end
end

function GetPX()
	if HideMicroButtonAndBags["Positions"] == "Right" then
		return 1;
	else
		return -1;
	end
end

function GetPX2()
	local x;
	if UnitInVehicle("player") then
		x = 3;
	else
		x = 1;
	end

	if HideMicroButtonAndBags["Positions"] == "Right" then
		return 1*x;
	else
		return -1*x;
	end
end

function addon:initialize()
	if HideMicroButtonAndBags == nil then
		HideMicroButtonAndBags = {};
		HideMicroButtonAndBags["Hide"] = false;
		HideMicroButtonAndBags["Positions"] = "Right";
	else
		if HideMicroButtonAndBags["Hide"] == nil		then HideMicroButtonAndBags["Hide"] = false; end
		if HideMicroButtonAndBags["Positions"] == nil	then HideMicroButtonAndBags["Positions"] = "Right"; end
	end

	HideMicroButtonAndBags["Hide"] = true;

	self:posMBAG();
	self:HideMBAG();
	addon:ClearAllPoints();
	addon:SetPoint(GetAnchor1(), MainMenuBar, GetAnchor2(), 0, 0);
	addon:SetSize(MicroButtonAndBagsBar:GetSize());
	addon:SetFrameLevel(2);
	MicroButtonAndBagsBar:SetSize(40,48);
	MicroButtonAndBagsBar:ClearAllPoints();
	MicroButtonAndBagsBar:SetPoint(GetAnchor1(), MainMenuBar, GetAnchor2(), 0, 0);

	MicroButtonAndBagsBar.MicroBagBar:Hide();

	MicroButtonsBorder:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
        edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
        tile = true, tileSize = 16, edgeSize = 16, 
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	});
	MicroButtonsBorder:SetBackdropColor(0,0,0,1);
	MicroButtonsBorder:ClearAllPoints();
	MicroButtonsBorder:SetPoint(GetAnchor1(), MainMenuMicroButton, GetAnchor1(), -4*GetPX(), -4);
	MicroButtonsBorder:SetSize(276,44);
	MicroButtonsBorder:SetParent(MicroButtonAndBagsBar);
	MicroButtonsBorder:SetFrameLevel(3);
	
	local ob = MainMenuBarBackpackButton:CreateTexture();
	ob:SetAllPoints();
	ob:SetTexture("Interface/Buttons/ActionBarFlyoutButton");
	ob:SetTexCoord(0.01562500, 0.67187500, 0.39843750, 0.72656250);
	ob:SetSize(44,44);
	ob:ClearAllPoints();
	ob:SetPoint("CENTER");
	MainMenuBarBackpackButton.outBorder = ob;

	for id, button in pairs(buttons) do
		if id > 12 then
			local tex = button:CreateTexture();
			tex:SetAllPoints();
			tex:SetTexture("Interface/Buttons/UI-Quickslot2");
			tex:SetSize(56,56);
			tex:ClearAllPoints();
			tex:SetPoint("CENTER");
			button.outBorder = tex;
		end
	end

	if HideMicroButtonAndBags["Hide"] then
		MainMenuMicroButton:SetAlpha(0);
	end
	MainMenuMicroButton:HookScript("OnEnter", function(self)
		addon:ShowMBAG();
	end);
	MainMenuMicroButton:RegisterForClicks("MiddleButtonUp");
	MainMenuMicroButton:HookScript("OnMouseUp", function(self, btn, down)
		if btn == "MiddleButton" then
			if MouseIsOver(MainMenuMicroButton) then
				if HideMicroButtonAndBags["Hide"] then
					HideMicroButtonAndBags["Hide"] = false;
				else
					HideMicroButtonAndBags["Hide"] = true;
				end
				--HideMicroButtonAndBags["Hide"] = not HideMicroButtonAndBags["Hide"];
				if not HideMicroButtonAndBags["Hide"] then
					MainMenuMicroButton:SetAlpha(1);
				end
				addon:HideMBAG();
			elseif MouseIsOver(MainMenuBarArtFrame.LeftEndCap) then
				HideMicroButtonAndBags["Positions"] = "Left";
				addon:posMBAG();
			elseif MouseIsOver(OverrideActionBarEndCapL) then
				HideMicroButtonAndBags["Positions"] = "Left";
				addon:posMBAG();
			elseif MouseIsOver(MainMenuBarArtFrame.RightEndCap) then
				HideMicroButtonAndBags["Positions"] = "Right";
				addon:posMBAG();
			elseif MouseIsOver(OverrideActionBarEndCapR) then
				HideMicroButtonAndBags["Positions"] = "Right";
				addon:posMBAG();
			end
		end
	end);

	addon:SetScript("OnLeave", function(self)
		if not MouseIsOver(addon) then
			addon:HideMBAG();
		end
	end);

	MicroButtonsBorder:SetScript("OnLeave", function(self)
		if not MouseIsOver(addon) then
			addon:HideMBAG();
		end
	end);

	for id, button in pairs(buttons) do
		if id > 1 then
			hooksecurefunc(button, "SetAlpha", function(self, a)
				if done then 
					return
				end
				done = true;
				if HideMicroButtonAndBags["Hide"] and not MicroButtonAndBagsBar:IsShown() and onload then
					addon:HideMBAG();
				end
				done = false;
			end);
		else
			
			hooksecurefunc(button, "SetAlpha", function(self, a)
				if done then 
					return
				end
				done = true;
				if not MicroButtonAndBagsBar:IsShown() and onload then
					addon:HideMBAG();
				end
				done = false;
			end);
		end
		button:HookScript("OnLeave", function(self)
			if not MouseIsOver(addon) then
				addon:HideMBAG();
			end
		end);
	end
end

function addon:ShowMBAG()
	local prev;
	MicroButtonAndBagsBar:Show();
	addon:Show();
	MainMenuMicroButton:SetAlpha(1);
	MicroButtonsBorder:SetFrameLevel(3);
	for id, button in pairs(buttons) do
		button:SetAlpha(1);
		button:EnableMouse(true);
		button:SetFrameLevel(4);
		if id > 1 and id < 12 then
			button:ClearAllPoints();
			button:SetPoint(GetAnchor1(), prev, GetAnchor2(), -4*GetPX(), 0);
		end
		prev = button;
	end
end

function addon:HideMBAG()
	if HideMicroButtonAndBags["Hide"] then
		MainMenuMicroButton:SetAlpha(0);
	end
	MicroButtonAndBagsBar:Hide();
	addon:Hide();
	for id, button in pairs(buttons) do
		if id > 1 and id < 12 then
			button:SetAlpha(0.0);
			button:EnableMouse(false);
			button:ClearAllPoints();
			button:SetPoint("CENTER", MainMenuMicroButton, "CENTER", 0, 0);
			button:SetFrameLevel(3);
		end
	end
end

function addon:posMBAG()
	addon:ClearAllPoints();addon:SetPoint(GetAnchor1(), MainMenuBar, GetAnchor2(), 0, 0);
	MicroButtonAndBagsBar:ClearAllPoints();MicroButtonAndBagsBar:SetPoint(GetAnchor1(), MainMenuBar, GetAnchor2(), 0, 0);
	MicroButtonsBorder:ClearAllPoints();MicroButtonsBorder:SetPoint(GetAnchor1(), MainMenuMicroButton, GetAnchor1(), -4*GetPX(), -4);
	MainMenuMicroButton:ClearAllPoints();MainMenuMicroButton:SetPoint(GetAnchor1(), MicroButtonAndBagsBar, GetAnchor2(), -35*GetPX(), 3);
	MainMenuBarBackpackButton:ClearAllPoints();MainMenuBarBackpackButton:SetPoint(GetAnchor1(), MicroButtonAndBagsBar, GetAnchor2(), -35*GetPX(), 43);
	CharacterBag0Slot:ClearAllPoints();CharacterBag0Slot:SetPoint(GetAnchor1(), MainMenuBarBackpackButton, GetAnchor2(), 4*GetPX(), 0);
	CharacterBag1Slot:ClearAllPoints();CharacterBag1Slot:SetPoint(GetAnchor1(), CharacterBag0Slot, GetAnchor2(), 4*GetPX(), 0);
	CharacterBag2Slot:ClearAllPoints();CharacterBag2Slot:SetPoint(GetAnchor1(), CharacterBag1Slot, GetAnchor2(), 4*GetPX(), 0);
	CharacterBag3Slot:ClearAllPoints();CharacterBag3Slot:SetPoint(GetAnchor1(), CharacterBag2Slot, GetAnchor2(), 4*GetPX(), 0);
end

hooksecurefunc("UIParent_ManageFramePositions", function() 
	if not MicroButtonAndBagsBar:IsShown() and onload then
		addon:HideMBAG();
	end
end);